=== debian/changelog ===
mysql-shell (8.0.36+dfsg-0ubuntu1) noble; urgency=medium

  * Initial release (LP: #2003316)

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 11 Apr 2024 06:25:42 -0700
