=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
NUMJOBS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

%:
	dh  $@ --buildsystem=cmake

override_dh_auto_configure:
	cp debian/additions/* ext/linenoise-ng/src/
	tar -zxpf /usr/src/mysql/mysql-source-8.0.tar.gz -C .
	mkdir mysql-8.0/bld && cd mysql-8.0/bld && cmake .. \
		-DWITH_BOOST=../boost/boost_1_77_0 \
		-DWITH_SSL=system \
		-DWITH_LIBEVENT=system \
		-DWITH_PROTOBUF=system \
		-DWITH_FIDO=none \
		-DWITH_ICU=system \
		-DWITH_LZ4=system \
		-DWITH_ZLIB=system \
		&& make -j$(NUMJOBS)
	dh_auto_configure -- \
		-G 'Unix Makefiles' \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DUSE_LD_LLD=OFF \
		-DMYSQL_SOURCE_DIR=mysql-8.0 \
		-DMYSQL_BUILD_DIR=mysql-8.0/bld \
		-DHAVE_PYTHON=1 \
		-DWITH_LZ4=system \
		-DWITH_PROTOBUF=system \
		-DWITH_ZSTD=system \
		-DWITH_ZLIB=system \
		-DCMAKE_CXX_FLAGS="-Wno-error=stringop-overflow" \
		.

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

TMP_INSTDIR = $(CURDIR)/debian/tmp
PRIVATE_BINDIR = /usr/lib/mysqlsh

override_dh_auto_install:
	dh_auto_install -- libdir=$(PRIVATE_BINDIR) DESTDIR=$(TMP_INSTDIR)
	# Only install headers for "mysqlshdk" as requested by upstream
	-rm -fr debian/tmp/usr/include 2>/dev/null
	-rm -fr debian/tmp/usr/lib*/*.{so*,a} 2>/dev/null
